﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Drawing.Printing;
using PDFCreatorPilotLib;


namespace PrintPDF
{
    class Program
    {
        static void Main()
        {
            string printername = DefaultPrinterName();
            string filename = "test.pdf";
            PrintPDF(filename, printername);
        }

        private static string DefaultPrinterName()
        {
            string functionReturnValue = null;
            System.Drawing.Printing.PrinterSettings oPS = new System.Drawing.Printing.PrinterSettings();
            try 
            {
                functionReturnValue = oPS.PrinterName;
            }
            catch (System.Exception ex) 
            {
                functionReturnValue = "";
            }
            finally 
            {
                oPS = null;
            }
            return functionReturnValue;
        }
        private static PrintDocument doc = new PrintDocument();
        private static int iPage;
        private static PDFCreatorPilotLib.PDFDocument4Class pdf;
        private static void doc_PrintPage(object sender, PrintPageEventArgs e)
        {
            float logpixelsx = e.Graphics.DpiX;
            float logpixelsy = e.Graphics.DpiY;
 
            long resolution = pdf.PageResolution;
            float zoomX = (float)resolution / logpixelsx;
            float zoomY = (float)resolution / logpixelsy;

            pdf.DrawPageToDC((int)e.Graphics.GetHdc(), iPage-1, zoomX, zoomY, true);
            
            iPage++;
            e.HasMorePages = (iPage<pdf.GetPageCount());
        }

        public static int PrintPDF(String filename, String printername)
        {
            pdf = new PDFCreatorPilotLib.PDFDocument4Class();
            pdf.Open(filename,"");
            doc.DocumentName = filename;
            doc.PrinterSettings.PrinterName = printername;
            doc.PrintPage += new PrintPageEventHandler(doc_PrintPage);
            iPage = 1;
            doc.Print();
            return 0;
        }
    }
}
